package com.eactive.eai.batch.job.jobItem.bokex;

import java.util.HashMap;
import java.lang.String;
import java.io.ByteArrayOutputStream;

import com.eactive.eai.common.exception.ExceptionUtil;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobHandle.JobProcessData;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

public class RECV_BOKEX_03100040 extends DefaultTelegram implements TelegramService
{
    /**
     * 생성자
     */
    public RECV_BOKEX_03100040() {
        //파일 확인 응답
    }

    /**
     * 전문 해체하기
     */
    public boolean doExecute() {
        if (!super.doExecute()) return false;

        String rtn_cd =  new String ((byte[]) al_Field.get(9));

        String uuid = this.batchDoc.getBatchMsg().getHeader().getUUID();
        JobProcessData job = JobProcessData.getInstance();
        HashMap<String, Object> hm = job.getBatchStageData(uuid);

        if (rtn_cd.equals("00")) {

            if ( batchDoc.getBatchMsg().getHeader().getFileSize() <= batchDoc.getBatchMsg().getBody().getCurFileSize()){
                this.setConditionTxt(TelegramKeys.EOF);
            }

            hm.put(JobProcessData.PROCDATA_BLOCKDATA, null);    // Vector 초기화

        } else {
            // 이전에 송신한 최초 시퀀스 찾아 내어 시퀀스 번호 다시 세팅
            int seq_no = batchDoc.getBatchMsg().getBody().getSeqNum();
            for ( int inx=0;inx<seq_no;inx++){
                Object obj = hm.get(new Integer(inx));
                if ( obj!= null ){
                    batchDoc.getBatchMsg().getBody().setSeqNum(inx+1);
                    break;
                }
            }
        }
        return true;
    }

    /**
     * 전문 Validation
     */
    public boolean doValidation()
    {
        if (!super.doValidation()) return false;
        return true;
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;
        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<9; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=9; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }
    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        String telegramNo = super.getFieldValueString(4);
        if ( telegramNo.length() < 8 ) return "";
        return telegramNo.substring(0,3) + telegramNo.substring(6,7);
    }

    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(8);
    }
}